#!/usr/bin/python3
import os
import time
import subprocess

basedirectory = r"/home/usr/proj/phlogmanager"
rawdirectory = basedirectory + r"/raw"
destdirectory = basedirectory + r"/formatted"
indexfile = basedirectory + r"/gophermap"

class File:
    def __init__(self, name, date):
        self.name = name
        self.date = date
    def __lt__(self, thing):
        return self.date < thing.date
    def __gt__(self, thing):
        return self.date > thing.date

header = [
    " _ _ _\n",
    "| (_) |__  _ __ __ _ _ __ _   _\n",
    "| | | '_ \| '__/ _` | '__| | | |\n",
    "| | | |_) | | | (_| | |  | |_| |\n",
    "|_|_|_.__/|_|  \__,_|_|   \__, |\n",
    "the collection of locally |___/\n",
    "sourced knowledge @ beepboop.systems\n",
    "1back to the root\t/\tbeepboop.systems\t70\n",
    "\n",
    "randomuser's writing\n",
    "~~~~~~~~~~~~~~~~~~~~\n",
    "1see the raw text (for proxy users)\t/library/raw/\tbeepboop.systems\t70\n",
    "\n",
]

def filename(f):
    return f.date + "-" + '-'.join(f.name.split(' ')) + ".txt"

rawfiles = os.listdir(rawdirectory)
data = []
for i in rawfiles:
    isplit = i.split('-')
    date = isplit[0]
    name = ' '.join(isplit[1:]).split('.')[0]

    data.append(File(name, date))

data.sort()
data.reverse()

# format every file in raw/

subprocess.Popen(["sh", "-c", "rm " + destdirectory + "/*"])

time.sleep(3)

for i in data:
    subprocess.Popen(["sh", "-c",
        "<" + rawdirectory + "/" + filename(i) + " uml >"
        + destdirectory + "/" + filename(i)])

fd = open(indexfile, "w")
fd.writelines(header)

c = 0
for i in data:
    if len(i.name) > c:
        c = len(i.name)
c += 2

for i in data:
    fd.write("0" + i.name.ljust(c) + "(" + i.date + ")\tformatted/" + filename(i) + "\n")

fd.write("\nfile generated by phman {}".format(time.time()))
fd.close()
